﻿namespace Wariancja
{
    interface ITypInwariantny<T>
    {
        void Nic();
        void Przyjmuje(T t);
        T Zwróć();
        T PrzyjmijIZwróć(T t);
    }

    class TypInwariantny<T> : ITypInwariantny<T>
    {
        public void Nic()
        {            
        }        

        public void Przyjmuje(T t)
        {
            Console.WriteLine(t);
        }

        public T Zwróć()
        {
            return default(T);
        }

        public T PrzyjmijIZwróć(T t)
        {
            Console.WriteLine(t);
            return t;
        }
    }

    interface ITypKontrawariantny<in T>
    {
        void Nic();
        void Przyjmuje(T t);
        //T Zwróć();
        //T PrzyjmijIZwróć(T t);
    }

    class TypKontrawariantny<T> : ITypKontrawariantny<T>
    {
        public void Nic()
        {
        }

        public void Przyjmuje(T t)
        {
            Console.WriteLine(t);
        }

        /*
        public T Zwróć()
        {
            return default(T);
        }

        public T PrzyjmijIZwróć(T t)
        {
            Console.WriteLine(t);
            return t;
        }
        */
    }

    interface ITypKowariantny<out T>
    {
        void Nic();
        //void Przyjmuje(T t);
        T Zwróć();
        //T PrzyjmijIZwróć(T t);
    }

    class TypKowariantny<T> : ITypKowariantny<T>
    {
        public void Nic()
        {
        }

        public void Przyjmuje(T t)
        {
            Console.WriteLine(t);
        }

        public T Zwróć()
        {
            return default(T);
        }

        public T PrzyjmijIZwróć(T t)
        {
            Console.WriteLine(t);
            return t;
        }
    }

    internal class Program
    {
        static void Main(string[] args)
        {
            ITypInwariantny<object> o11 = new TypInwariantny<object>();
            TypInwariantny<object> o12 = new TypInwariantny<object>();

            ITypInwariantny<string> o13 = new TypInwariantny<string>();
            TypInwariantny<string> o14 = new TypInwariantny<string>();

            //ITypInwariantny<object> o15 = new TypInwariantny<string>();
            //TypInwariantny<object> o16 = new TypInwariantny<string>();

            //ITypInwariantny<string> o17 = new TypInwariantny<object>();
            //TypInwariantny<string> o18 = new TypInwariantny<object>();

            ITypKontrawariantny<object> o21 = new TypKontrawariantny<object>();
            TypKontrawariantny<object> o22 = new TypKontrawariantny<object>();

            ITypKontrawariantny<string> o23 = new TypKontrawariantny<string>();
            TypKontrawariantny<string> o24 = new TypKontrawariantny<string>();

            //ITypKontrawariantny<object> o25 = new TypKontrawariantny<string>();
            //TypKontrawariantny<object> o26 = new TypKontrawariantny<string>();

            ITypKontrawariantny<string> o27 = new TypKontrawariantny<object>();
            //TypKontrawariantny<string> o28 = new TypKontrawariantny<object>();

            ITypKowariantny<object> o31 = new TypKowariantny<object>();
            TypKowariantny<object> o32 = new TypKowariantny<object>();

            ITypKowariantny<string> o33 = new TypKowariantny<string>();
            TypKowariantny<string> o34 = new TypKowariantny<string>();

            ITypKowariantny<object> o35 = new TypKowariantny<string>();
            //TypKowariantny<object> o36 = new TypKowariantny<string>();

            //ITypKowariantny<string> o37 = new TypKowariantny<object>();
            //TypKowariantny<string> o38 = new TypKowariantny<object>();
        }
    }
}